"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WalletConnectConnector = void 0;
var web3_provider_1 = __importDefault(require("@walletconnect/web3-provider"));
var WalletConnectConnector = /** @class */ (function () {
    function WalletConnectConnector(opts) {
        this.provider = new web3_provider_1.default(opts);
        this.id = "wallet_connect_connector_".concat(opts.infuraId);
    }
    WalletConnectConnector.prototype.getProvider = function () {
        return this.provider;
    };
    WalletConnectConnector.prototype.subscribeToAccountsChanged = function (cb) {
        var _this = this;
        this.provider.on("accountsChanged", cb);
        return function () { return _this.provider.removeListener("accountsChanged", cb); };
    };
    WalletConnectConnector.prototype.subscribeToChainChanged = function (cb) {
        var _this = this;
        var callback = function (chainId) { return cb(_this.formatChainId(chainId)); };
        this.provider.on("chainChanged", callback);
        return function () { return _this.provider.removeListener("chainChanged", callback); };
    };
    WalletConnectConnector.prototype.synchronize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var rawWalletConnectItem, walletConnectItem, accounts, chainId, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        rawWalletConnectItem = localStorage.getItem("walletconnect");
                        if (!rawWalletConnectItem) return [3 /*break*/, 5];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        walletConnectItem = JSON.parse(rawWalletConnectItem);
                        if (!walletConnectItem.connected) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.provider.enable()];
                    case 2:
                        accounts = _a.sent();
                        chainId = this.provider.chainId;
                        return [2 /*return*/, {
                                accounts: accounts,
                                chainId: this.formatChainId(chainId),
                                selectedProvider: "WalletConnect",
                            }];
                    case 3: return [3 /*break*/, 5];
                    case 4:
                        err_1 = _a.sent();
                        localStorage.removeItem("walletconnect");
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/, null];
                }
            });
        });
    };
    WalletConnectConnector.prototype.connect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var accounts, chainId, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.provider.enable()];
                    case 1:
                        accounts = _a.sent();
                        chainId = this.provider.chainId;
                        return [2 /*return*/, {
                                accounts: accounts,
                                chainId: this.formatChainId(chainId),
                                selectedProvider: "WalletConnect",
                            }];
                    case 2:
                        err_2 = _a.sent();
                        localStorage.removeItem("walletconnect");
                        throw new Error("Fail to connect!");
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    WalletConnectConnector.prototype.disconnect = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.provider.disconnect()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    WalletConnectConnector.prototype.formatChainId = function (chainId) {
        return "0x".concat(Number(chainId).toString());
    };
    return WalletConnectConnector;
}());
exports.WalletConnectConnector = WalletConnectConnector;
