"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalStorageHelper = exports.LOCAL_STORAGE_KEY = void 0;
exports.LOCAL_STORAGE_KEY = "eth-provider-gatherer_keys";
var LocalStorageHelper = /** @class */ (function () {
    function LocalStorageHelper() {
    }
    LocalStorageHelper.getKeys = function () {
        var item = localStorage.getItem(exports.LOCAL_STORAGE_KEY);
        if (!item)
            return [];
        try {
            var providerKeys = JSON.parse(item);
            if (!Array.isArray(providerKeys) ||
                providerKeys.some(function (e) { return typeof e !== "string"; })) {
                localStorage.removeItem(exports.LOCAL_STORAGE_KEY);
                return [];
            }
            return providerKeys;
        }
        catch (err) {
            localStorage.removeItem(exports.LOCAL_STORAGE_KEY);
            return [];
        }
    };
    LocalStorageHelper.addKey = function (key) {
        var keySet = new Set(this.getKeys());
        keySet.add(key);
        localStorage.setItem(exports.LOCAL_STORAGE_KEY, JSON.stringify(Array.from(keySet)));
    };
    LocalStorageHelper.removeKey = function (key) {
        var keySet = new Set(this.getKeys());
        keySet.delete(key);
        localStorage.setItem(exports.LOCAL_STORAGE_KEY, JSON.stringify(Array.from(keySet)));
    };
    return LocalStorageHelper;
}());
exports.LocalStorageHelper = LocalStorageHelper;
