import WalletConnectProvider from "@walletconnect/web3-provider";
import { EthProvider, ProviderKey } from "../common";
import { ProviderState } from "../reducer";
declare type UseProvider = {
    status: "unavailable";
    account: null;
    chainId: null;
    provider: null;
    key: ProviderKey;
    connect: () => Promise<void>;
    disconnect: () => Promise<void>;
} | {
    status: "notConnected";
    account: null;
    chainId: null;
    provider: EthProvider | WalletConnectProvider;
    key: ProviderKey;
    connect: () => Promise<void>;
    disconnect: () => Promise<void>;
} | (ProviderState & {
    connect: () => Promise<void>;
    disconnect: () => Promise<void>;
    provider: EthProvider | WalletConnectProvider;
});
export declare function useProvider(providerKey: ProviderKey): UseProvider;
export declare function useConnectedProvider(providerKey: ProviderKey): {
    provider: WalletConnectProvider | EthProvider;
    chainId: string;
    account: string;
    key: string;
    disconnect: () => Promise<void>;
};
export declare function useSelectedProvider(): {
    provider: WalletConnectProvider | EthProvider;
    chainId: string;
    account: string;
    key: string;
    disconnect: () => Promise<void>;
};
export {};
