"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSelectedProvider = exports.useConnectedProvider = exports.useProvider = void 0;
var React = __importStar(require("react"));
var use_ethpp_1 = require("./use-ethpp");
function useProvider(providerKey) {
    var _a = (0, use_ethpp_1.useEthpp)(), providers = _a.providers, connectProvider = _a.connectProvider, disconnectProvider = _a.disconnectProvider, providerConnectors = _a.providerConnectors;
    if (!(providerKey in providerConnectors)) {
        throw new Error("Connector not existing :(");
    }
    var connect = React.useCallback(function () { return connectProvider(providerKey); }, [providerKey, connectProvider]);
    var disconnect = React.useCallback(function () { return disconnectProvider(providerKey); }, [providerKey, disconnectProvider]);
    var providerState = providers[providerKey];
    var provider = React.useMemo(function () {
        var connector = providerConnectors[providerKey];
        if (!connector)
            return null;
        return connector.getProvider();
    }, [providerKey, providerConnectors]);
    if (!providerState) {
        if (!provider) {
            return {
                status: "unavailable",
                account: null,
                chainId: null,
                provider: provider,
                key: providerKey,
                connect: connect,
                disconnect: disconnect,
            };
        }
        return {
            status: "notConnected",
            account: null,
            chainId: null,
            provider: provider,
            key: providerKey,
            connect: connect,
            disconnect: disconnect,
        };
    }
    return __assign(__assign({}, providerState), { connect: connect, disconnect: disconnect, provider: provider });
}
exports.useProvider = useProvider;
function useConnectedProvider(providerKey) {
    var providerState = useProvider(providerKey);
    if (providerState.status !== "connected") {
        throw new Error("`useConnectedProvider` can be used only once the provider has been connected.");
    }
    return {
        provider: providerState.provider,
        chainId: providerState.chainId,
        account: providerState.account,
        key: providerKey,
        disconnect: providerState.disconnect,
    };
}
exports.useConnectedProvider = useConnectedProvider;
function useSelectedProvider() {
    var selectedProvider = (0, use_ethpp_1.useEthpp)().selectedProvider;
    if (!selectedProvider) {
        throw new Error("`useSelectedProvider` can be used only once a provider has been selected");
    }
    return useConnectedProvider(selectedProvider);
}
exports.useSelectedProvider = useSelectedProvider;
