import * as React from "react";
import { ProviderKey, ProviderConnectors } from "./common";
import { State } from "./reducer";
export declare type IEthppContext = State & {
    connectProvider: (providerKey: ProviderKey) => Promise<void>;
    disconnectProvider: (providerKey: ProviderKey) => Promise<void>;
    selectProvider: (providerKey: ProviderKey) => void;
    providerConnectors: ProviderConnectors;
    globalStatus: "initializing" | "notConnected" | "connected";
};
export declare const EthppContext: React.Context<IEthppContext | undefined>;
declare type EthppProps = React.PropsWithChildren<{
    providerConnectors?: ProviderConnectors;
}>;
export declare function EthppProvider({ providerConnectors, ...otherProps }: EthppProps): JSX.Element;
export {};
