"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EthppProvider = exports.EthppContext = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var reducer_1 = require("./reducer");
var helpers_1 = require("./helpers");
var _1 = require(".");
var use_safe_dispatch_1 = require("./helpers/use-safe-dispatch");
exports.EthppContext = React.createContext(undefined);
function EthppProvider(_a) {
    var _this = this;
    var _b = _a.providerConnectors, providerConnectors = _b === void 0 ? _1.DEFAULT_CONNECTORS : _b, otherProps = __rest(_a, ["providerConnectors"]);
    var providerConnectorsRef = React.useRef(providerConnectors);
    var _c = React.useReducer(reducer_1.reducer, reducer_1.initialState), state = _c[0], unsafeDispatch = _c[1];
    var dispatch = (0, use_safe_dispatch_1.useSafeDispatch)(unsafeDispatch);
    var _d = React.useState(false), isReady = _d[0], setIsReady = _d[1];
    var selectedProvider = state.selectedProvider, connectedKeys = state.connectedKeys;
    React.useEffect(function () {
        function subscribe() {
            return (0, helpers_1.subscribeToAccountAndChainChanged)({
                dispatch: dispatch,
                providerConnectors: providerConnectorsRef.current,
                connectedKeys: connectedKeys,
            });
        }
        var unsubscribe = subscribe();
        return unsubscribe;
    }, [connectedKeys, dispatch]);
    var disconnectProvider = React.useCallback(function (providerKey) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(providerKey in providerConnectorsRef.current)) {
                        throw new Error("Connector not existing :(");
                    }
                    if (!connectedKeys.includes(providerKey)) {
                        throw new Error("Provider not connected!");
                    }
                    return [4 /*yield*/, (0, helpers_1.disconnectWallet)({
                            dispatch: dispatch,
                            providerConnectors: providerConnectorsRef.current,
                            providerKey: providerKey,
                        })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); }, [connectedKeys, dispatch]);
    var connectProvider = React.useCallback(function (providerKey) { return __awaiter(_this, void 0, void 0, function () {
        var err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(providerKey in providerConnectorsRef.current)) {
                        throw new Error("Connector not existing :(");
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, (0, helpers_1.connectWallet)({
                            dispatch: dispatch,
                            providerConnectors: providerConnectorsRef.current,
                            providerKey: providerKey,
                        })];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    console.error(err_1);
                    throw new Error("Error while connecting :(");
                case 4: return [2 /*return*/];
            }
        });
    }); }, [dispatch]);
    var selectProvider = React.useCallback(function (providerKey) {
        if (!(providerKey in providerConnectorsRef.current)) {
            throw new Error("Connector not existing :(");
        }
        dispatch({ type: "selectedProviderChanged", payload: { providerKey: providerKey } });
    }, [dispatch]);
    React.useEffect(function () {
        (0, helpers_1.synchronize)({
            dispatch: dispatch,
            providerConnectors: providerConnectorsRef.current,
        }).finally(function () { return setIsReady(true); });
    }, [dispatch]);
    var value = __assign(__assign({}, state), { providerConnectors: providerConnectorsRef.current, connectProvider: connectProvider, disconnectProvider: disconnectProvider, selectProvider: selectProvider, globalStatus: !isReady
            ? "initializing"
            : !selectedProvider
                ? "notConnected"
                : "connected" });
    return (0, jsx_runtime_1.jsx)(exports.EthppContext.Provider, __assign({ value: value }, otherProps), void 0);
}
exports.EthppProvider = EthppProvider;
