import { ProviderKey } from "./common";
export declare type Action = {
    type: "connected";
    payload: {
        accounts: string[];
        chainId: string;
        providerKey: ProviderKey;
    };
} | {
    type: "accountChanged";
    payload: {
        accounts: string[];
        providerKey: ProviderKey;
    };
} | {
    type: "chainChanged";
    payload: {
        chainId: string;
        providerKey: ProviderKey;
    };
} | {
    type: "disconnected";
    payload: {
        providerKey: ProviderKey;
    };
} | {
    type: "selectedProviderChanged";
    payload: {
        providerKey: ProviderKey;
    };
};
export declare type ConnectedState = {
    status: "connected";
    account: string;
    chainId: string;
    key: ProviderKey;
};
export declare type ProviderState = ConnectedState;
export declare type State = {
    selectedProvider: null | ProviderKey;
    connectedKeys: ProviderKey[];
    providers: Record<ProviderKey, ProviderState>;
};
export declare const initialState: State;
export declare function reducer(state: State, action: Action): State;
