"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.reducer = exports.initialState = void 0;
var helpers_1 = require("./helpers");
exports.initialState = {
    selectedProvider: null,
    connectedKeys: [],
    providers: {},
};
function reducer(state, action) {
    var _a, _b, _c;
    switch (action.type) {
        case "connected":
            return {
                selectedProvider: action.payload.providerKey,
                connectedKeys: Array.from(new Set(__spreadArray(__spreadArray([], state.connectedKeys, true), [action.payload.providerKey], false))),
                providers: __assign(__assign({}, state.providers), (_a = {}, _a[action.payload.providerKey] = {
                    status: "connected",
                    account: action.payload.accounts[0],
                    chainId: action.payload.chainId,
                    key: action.payload.providerKey,
                }, _a)),
            };
        case "chainChanged":
            var providerState_chainChanged = state.providers[action.payload.providerKey];
            if (!providerState_chainChanged) {
                console.warn("Unreachable chainChanged. Please file an issue.");
                return state;
            }
            return __assign(__assign({}, state), { providers: __assign(__assign({}, state.providers), (_b = {}, _b[action.payload.providerKey] = __assign(__assign({}, providerState_chainChanged), { chainId: action.payload.chainId }), _b)) });
        case "accountChanged":
            var providerState_accountChanged = state.providers[action.payload.providerKey];
            if (!providerState_accountChanged) {
                console.warn("Unreachable accountChanged. Please file an issue.");
                return state;
            }
            // MetaMask particular case
            if (action.payload.accounts.length === 0) {
                var isSelectedSigner_1 = state.selectedProvider === action.payload.providerKey;
                var providersState_accountChanged = __assign({}, state.providers);
                delete providersState_accountChanged[action.payload.providerKey];
                helpers_1.LocalStorageHelper.removeKey(action.payload.providerKey);
                return {
                    selectedProvider: isSelectedSigner_1 ? null : state.selectedProvider,
                    connectedKeys: state.connectedKeys.filter(function (key) { return key !== action.payload.providerKey; }),
                    providers: providersState_accountChanged,
                };
            }
            return __assign(__assign({}, state), { providers: __assign(__assign({}, state.providers), (_c = {}, _c[action.payload.providerKey] = __assign(__assign({}, providerState_accountChanged), { account: action.payload.accounts[0] }), _c)) });
        case "disconnected":
            var isSelectedSigner = state.selectedProvider === action.payload.providerKey;
            var providersState_disconnected = __assign({}, state.providers);
            delete providersState_disconnected[action.payload.providerKey];
            return {
                selectedProvider: isSelectedSigner ? null : state.selectedProvider,
                connectedKeys: state.connectedKeys.filter(function (key) { return key !== action.payload.providerKey; }),
                providers: providersState_disconnected,
            };
        case "selectedProviderChanged":
            if (!state.connectedKeys.includes(action.payload.providerKey)) {
                console.warn("Invalid not connected provider selected.");
                return state;
            }
            return __assign(__assign({}, state), { selectedProvider: action.payload.providerKey });
        default:
            return state;
    }
}
exports.reducer = reducer;
